﻿from . import _window


def label_path(path_or_column: str | int, row: int = None, window_id: int = 0) -> str:
    path = path_or_column
    if isinstance(path_or_column, int):
        path = f'wnd[{window_id}]/usr/lbl[{path_or_column},{row}]'
    path = window.check_id(path, window_id)
    return check_wnd(path, window_id)


def button_path(path_or_number: str | int, container: int = None, window_id: int=0):
    path = path_or_number
    if isinstance(path_or_number, int):
        path = f'wnd[{window_id}]/tbar[{container}]/btn[{str(path_or_number)}]'
    path = check_wnd(path)
    return window.check_id(path, window_id)


def checkbox_path(path_or_column: str | int, row: int = None, window_id: int = 0) -> str:
    path = path_or_column
    if isinstance(path_or_column, int):
        path = f'wnd[{window_id}]/usr/chk[{path_or_column},{row}]'
    path = check_wnd(path)
    return window.check_id(path, window_id)


def check_wnd(path: str, window_id: int = 0) -> str:
    if 'wnd[' not in path:
        path = f"wnd[{window_id}]{path}"
    return path


"""
namespace As.It.Ses.Frameworks.Selenium.Sap.Gui.General
{
  using OpenQA.Selenium;
  using System;
  using System.Text.RegularExpressions;
  using System.Threading;

  public static class Elements
    {
      public static int WaitInSeconds = 0;
      public static class Checks
      {
        public static bool HasClass(IWebElement element, string className, bool findExactly = false)
        {
          if (findExactly)
          {
            return string.Equals(element.GetAttribute("class"), className, StringComparison.OrdinalIgnoreCase);
          }
          else
          {
            return element.GetAttribute("class").Contains(className, StringComparison.OrdinalIgnoreCase);
          }

        }
        public static bool IsReadonly(IWebElement element)
        {
          return (HasClass(element, "readonly", false));
        }
        public static bool CheckIfDownloadFailed()
        {
          if (Exists("popupWindowMessage-ib"))
          {
            return true;
          }
          return false;
        }

        public static bool Exists(string id)
        {
          return Exists(Elements.create.WebElement(id));
        }
        public static bool Exists(IWebElement element)
        {
          return (element != null) ? element.Displayed : false;
        }
      }
      public static class Create
      {
        public static IWebElement SapElement(string path)
        {
          return WebElement(path, true);
        }
        public static IWebElement WebElement(string id, bool sap = false)
        {
          id = (id.Contains("windowId")) ? Windows.SetId(id) : id;
          sap = (new Regex(@"wnd\[[0-9]\]").Match(id).Success) ? sap = true : sap = false;

          IWebElement element = null;
          int maxWaitTime = Elements.WaitInSeconds * 2;
          for (int counter = 0; counter <= maxWaitTime; counter++)
          {
            try
            {
              string xPath = "//*[contains(@lsdata, \"SID:'" + id + "'\")]";
              element = (sap) ? Sessions.SessionObj.FindElement(By.XPath(xPath)) : Sessions.SessionObj.FindElement(By.Id(id));
            }
            catch (Exception ex)
            {
              Thread.Sleep(500);
              counter++;
            }
            if (element != null) break;
          }
          return element;
        }       
      }
      public static IWebElement GetParentElement(IWebElement childElement, string tagName = null, int searchDepth = 10)
      {
        if (tagName == null)
        {
          return childElement.FindElement(By.XPath(".."));
        }
        else
        {
          IWebElement tempElement = childElement;
          for (int counter = 0; counter <= searchDepth; counter++)
          {
            tempElement = tempElement.FindElement(By.XPath(".."));
            if (tempElement.TagName.ToLower() == tagName.ToLower())
            {
              return tempElement;
            }
          }
        }
        return null;
      }
 

      

      public static IWebElement WaitForElement(string elementId, int waitingTimeSeconds = 2)
      {
        elementId = (elementId.Contains("windowId")) ? elementId.Replace("windowId", "0") : elementId;

        IWebElement element = null;
        int maxWaitingTime = waitingTimeSeconds * 2;
        for (int counter = 0; counter <= maxWaitingTime; counter++)
        {
          element = Create.WebElement(elementId);
          if (element is null) Thread.Sleep(500); else break;
        }
        return element;

      }
    }

    
}

'' ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
'' ** ** ** ** *Elemente ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
'' ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
Class
Elemente
Function
TableisteID(ID, FensterID)
If
mid(ID, 0, 1) = "/"
Then
ID = mid(ID, 1)
End
If
Set
TableisteID = SF(FensterID).SAPGuiTabStrip("id:=/app/con\[0\]/ses\[0\]/wnd\[" & FensterID & "\]/" & ID)
End
Function
Function
Tableiste(Name, FensterID)
Set
Tableiste = SF(FensterID).SAPGuiTabStrip("name:=" & Name, "type:=GuiTabStrip")
End
Function
Function
Transaktionsfeld()
Set
Transaktionsfeld = SitzungFenster(0).SAPGuiOKCode("name:=okcd")
End
Function
Function
SF(FensterID)
Set
SF = SapGui_Elemente.SitzungFenster(FensterID)
End
Function
Function
SitzungFenster(FensterID)
Set
SitzungFenster = SapGuiSession("name:=ses\[0\]").SapGuiWindow("name:=wnd\[" & FensterID & "\]")
End
Function
Function
S()
Set
S = SapGui_Elemente.Sitzung
End
Function
Function
Sitzung()
Set
Sitzung = SapGuiSession("name:=ses\[0\]")
End
Function
Function
F(FensterID)
Set
F = SapGui_Elemente.Fenster(FensterID)
End
Function
Function
Fenster(FensterID)
Set
Fenster = SapGui_Elemente.Sitzung().SapGuiWindow("name:=wnd\[" & FensterID & "\]")
End
Function
Function
EF(Feldname, FensterID)
Set
EF = SapGui_Elemente.Edit_Feld(Feldname, FensterID)
End
Function
Function
CEF(Feldname, FensterID)
Set
CEF = SapGui_Elemente.CEdit_Feld(Feldname, FensterID)
End
Function
Function
Edit_Feld(Feldname, FensterID)
If
instr(Feldname, ":=") > 0
Then
On
Error
Resume
Next
Set
Edit_Feld = SapGui_Elemente.SF(FensterID).SapGuiEdit(Feldname)
If
Err.number <> 0
Then
Set
Edit_Feld = SapGui_Elemente.CEdit_Feld(Feldname, FensterID)
Err.Clear
End
If
On
Error
GoTo
0
Else
On
Error
Resume
Next
Set
Edit_Feld = SapGui_Elemente.SF(FensterID).SapGuiEdit("name:=" & Feldname, "type:=GuiTextField")
If
Err.number <> 0
Then
Set
Edit_Feld = SapGui_Elemente.CEdit_Feld(Feldname, FensterID)
Err.Clear
End
If
On
Error
GoTo
0
End
If
End
Function
Function
CEdit_Feld(Feldname, FensterID)
If
instr(Feldname, ":=") > 0
Then
On
Error
Resume
Next
Set
CEdit_Feld = SapGui_Elemente.SF(FensterID).SapGuiEdit(Feldname, "type:=GuiCTextField")
If
Err.number <> 0
Then
Set
CEdit_Feld = SapGui_Elemente.Edit_Feld(Feldname, FensterID)
Err.Clear
End
If
On
Error
GoTo
0
Else
On
Error
Resume
Next
Set
CEdit_Feld = SapGui_Elemente.SF(FensterID).SapGuiEdit("name:=" & Feldname, "type:=GuiCTextField")
If
err.number <> 0
Then
Set
CEdit_Feld = SapGui_Elemente.Edit_Feld(Feldname, FensterID)
err.Clear
End
If
On
Error
GoTo
0
End
If
End
Function
Function
SE16_Tabelle()
Set
SE16_Tabelle = SapGui_Elemente.SF(0).SapGuiGrid("id:=/app/con\[0\]/ses\[0\]/wnd\[0\]/usr/cntlGRID1/shellcont/shell")
End
Function
Function
SE16_Tabellenname()
SE16_Tabellenname = "DATABROWSE-TABLENAME"
End
Function
Function
Tabellenobjekt()
Set
Tabellenobjekt = SE16_Tabelle()
If
Tabellenobjekt.exist(2) = false
Then
set
Tabellenobjekt = SapGui_Elemente.SF(0).SapGuiGrid("name:=shell", "guicomponenttype:=201")
End
If
End
Function
Function
SA38_Programmname()
SA38_Programmname = "RS38M-PROGRAMM"
End
Function
Function
SA38_Variante()
SA38_Variante = "RS38M-SELSET"
End
Function
Function
Statusleiste()
Set
Statusleiste = SapGui_Elemente.SF(0).SapGuiStatusBar("id:=/app/con\[0\]/ses\[0\]/wnd\[0\]/sbar")
End
Function
Function
Sitzungsnummer(Objekt)
lstrName = Objekt.Object.vorname_nachname
lstrName = Replace(lstrName, "ses[", "")
Sitzungsnummer = Replace(lstrName, "]", "")
End
Function
Function
Menueleiste()
Set
Menueleiste = SapGui_Elemente.SF(0).SapGuiMenubar("guicomponenttype:=111", "name:=mbar")
End
Function
Function
Checkbox_Name(Name, FensterID)
Set
Checkbox_Name = SapGui_Elemente.SF(FensterID).SapGuiCheckBox("guicomponenttype:=42", "name:=" & Name)
End
Function
Function
Checkbox(Spalte, Reihe, FensterID)
Set
Checkbox = SapGui_Elemente.SF(FensterID).SapGuiCheckBox("guicomponenttype:=42",
                                                        "id:=/app/con\[0\]/ses\[0\]/wnd\[" & FensterID & "\]/usr/chk\[" & Spalte & "," & Reihe & "\]")
End
Function
Function
Beschriftung(Spalte, Reihe, FensterID)
Set
Beschriftung = SapGui_Elemente.SF(FensterID).SapGuiLabel(
    "id:=/app/con\[0\]/ses\[0\]/wnd\[" & FensterID & "\]/usr/lbl\[" & Spalte & "," & Reihe & "\]")
End
Function

Function
Schaltflaeche(SchaltflaecheID, ContainerID, FensterID)
Set
Schaltflaeche = SapGui_Elemente.SF(FensterID).SapGuiButton("guicomponenttype:=40",
                                                           "name:=btn\[" & SchaltflaecheID & "\]",
                                                           "containername:=tbar\[" & ContainerID & "\]")
End
Function
Function
Schaltflaeche_Name(Name, FensterID)
Set
Schaltflaeche_Name = SapGui_Elemente.SF(FensterID).SapGuiButton("guicomponenttype:=40", "name:=" & Name)
End
Function
Function
Schaltflaeche_Id(Id, FensterID)
Set
Schaltflaeche_Id = SapGui_Elemente.SF(FensterID).SapGuiButton("guicomponenttype:=40", "id:=" & Id)
End
Function
Function
Radio(Name, FensterID)
Set
Radio = SapGui_Elemente.SF(FensterID).SapGuiRadioButton("name:=" & Name)
End
Function
End
Class
"""
